package org.rosuda.jrs;

import java.util.concurrent.atomic.AtomicInteger;

/**
 * Represents an R object that is not converted to Java types when returned.
 * The object is cached in the R environment.
 * <p>
 * TODO: Look at REXPReference, but not supported with Rserve.
 * <p>
 * Experimental.
 * @author Martyn Tebby
 */
public class ROpaque {

	/** Name of the cache variable. */
	public static final String name = "mycache";

	private static AtomicInteger counter = new AtomicInteger();

	private int id;

	/** Creates opaque with unique id. */
	ROpaque() {
		id = counter.incrementAndGet();
	}

	public String toString() {
		return name + "[[" + id + "]]";
	}

}
